# coding: utf-8

"""
    FastAPI

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from openapi_client.models.provider_endpoints_inner import ProviderEndpointsInner
from typing import Optional, Set
from typing_extensions import Self

class ProviderCreate(BaseModel):
    """
    ProviderCreate
    """ # noqa: E501
    id: Optional[StrictStr] = Field(default=None, alias="_id")
    friendly_name: StrictStr
    endpoints: Optional[List[ProviderEndpointsInner]] = None
    endpoint_default_type: Optional[StrictStr] = 'unknown'
    administrators: Optional[List[StrictStr]] = None
    __properties: ClassVar[List[str]] = ["_id", "friendly_name", "endpoints", "endpoint_default_type", "administrators"]

    @field_validator('endpoint_default_type')
    def endpoint_default_type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['web portal', 'unknown', 'irods', 'davrods', 'yoda web portal']):
            raise ValueError("must be one of enum values ('web portal', 'unknown', 'irods', 'davrods', 'yoda web portal')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ProviderCreate from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in endpoints (list)
        _items = []
        if self.endpoints:
            for _item_endpoints in self.endpoints:
                if _item_endpoints:
                    _items.append(_item_endpoints.to_dict())
            _dict['endpoints'] = _items
        # set to None if id (nullable) is None
        # and model_fields_set contains the field
        if self.id is None and "id" in self.model_fields_set:
            _dict['_id'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ProviderCreate from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_id": obj.get("_id"),
            "friendly_name": obj.get("friendly_name"),
            "endpoints": [ProviderEndpointsInner.from_dict(_item) for _item in obj["endpoints"]] if obj.get("endpoints") is not None else None,
            "endpoint_default_type": obj.get("endpoint_default_type") if obj.get("endpoint_default_type") is not None else 'unknown',
            "administrators": obj.get("administrators")
        })
        return _obj


